package main

import (
	"log"
	"time"
)

func nextSunriseSunsetTime(t time.Time) (sunrise, sunset time.Time, err error) {
	var (
		nextSR time.Time
		nextSS time.Time
	)

	s := config.SunRiseSet

	s.Date = t
	currentSR, currentSS, err := s.GetSunriseSunset()
	if err != nil {
		return time.Time{}, time.Time{}, err
	}

	s.Date = t.Add(24 * time.Hour)
	nextSR, nextSS, err = s.GetSunriseSunset()
	if err != nil {
		return time.Time{}, time.Time{}, err
	}

	var (
		nSR time.Time
		nSS time.Time
	)

	if currentSR.After(t) {
		nSR = currentSR
	} else {
		nSR = nextSR
	}

	if currentSS.After(t) {
		nSS = currentSS
	} else {
		nSS = nextSS
	}

	log.Printf("[TRACE] Next calculated sunrise: %s\n", nSR.Format("2006-01-02 15:04:05"))
	log.Printf("[TRACE] Next calculated sunset : %s\n", nSS.Format("2006-01-02 15:04:05"))

	return nSR, nSS, nil
}
